import { ComponentClass, StatelessComponent } from 'react';
import { I18nBundle } from 'pretur.i18n';
import { Reducer, Reducible, Action } from 'pretur.redux';
export interface PageReducerBuilder<T, S> {
    (data?: T): Reducer<S>;
}
export interface PageDescriptor<TProps, TState, TReducerBuilderData> {
    path: string;
    titleKey: string;
    hidden?: boolean;
    persistent?: boolean;
    component: ComponentClass<TProps> | StatelessComponent<TProps>;
    reducerBuilder: PageReducerBuilder<TReducerBuilderData, TState>;
}
export interface PageInstantiationData<TReducerBuilderData> {
    path: string;
    mutex: string;
    reducerBuilderData?: TReducerBuilderData;
    titleData?: any;
}
export declare class Page<TProps, TState, TReducerBuilderData> implements Reducible {
    private params;
    private currentState;
    constructor(descriptor: PageDescriptor<TProps, TState, TReducerBuilderData>, instantiationData: PageInstantiationData<TReducerBuilderData>);
    mutex: string;
    path: string;
    title: I18nBundle<string, any>;
    state: TState;
    descriptor: PageDescriptor<TProps, TState, TReducerBuilderData>;
    instantiationData: PageInstantiationData<TReducerBuilderData>;
    reduce(action: Action<any, any>): this;
}
