"use strict";
var Page = (function () {
    function Page(descriptor, instantiationData) {
        if (descriptor === null && instantiationData === null) {
            return;
        }
        var reducer = descriptor.reducerBuilder(instantiationData.reducerBuilderData);
        this.currentState = reducer(undefined, { type: '@@INIT_PAGE' });
        if (this.currentState === undefined) {
            throw new Error('The reducer did not return the initial state.');
        }
        this.params = {
            descriptor: descriptor,
            instantiationData: instantiationData,
            reducer: reducer,
            title: { key: descriptor.titleKey, data: instantiationData.titleData },
        };
    }
    Object.defineProperty(Page.prototype, "mutex", {
        get: function () {
            return this.params.instantiationData.mutex;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Page.prototype, "path", {
        get: function () {
            return this.params.descriptor.path;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Page.prototype, "title", {
        get: function () {
            return this.params.title;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Page.prototype, "state", {
        get: function () {
            return this.currentState;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Page.prototype, "descriptor", {
        get: function () {
            return this.params.descriptor;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Page.prototype, "instantiationData", {
        get: function () {
            return this.params.instantiationData;
        },
        enumerable: true,
        configurable: true
    });
    Page.prototype.reduce = function (action) {
        var newState = this.params.reducer(this.state, action);
        if (newState === this.state) {
            return this;
        }
        var clone = new Page(null, null);
        clone.params = this.params;
        clone.currentState = newState;
        return clone;
    };
    return Page;
}());
exports.Page = Page;
