import { ComponentClass, StatelessComponent } from 'react';
import { PageReducerBuilder, PageDescriptor, PageInstantiationData, Page } from './page';
export interface PageTreeRoot {
    [node: string]: PageTreeFolder | PageTreeLeaf;
}
export interface PageTreeFolder {
    titleKey: string;
    hidden?: boolean;
    contents: PageTreeRoot;
}
export interface PageTreeLeaf {
    titleKey: string;
    hidden?: boolean;
    persistent?: boolean;
    component: ComponentClass<any> | StatelessComponent<any>;
    reducerBuilder: PageReducerBuilder<any, any>;
}
export interface PageFolderDescriptor {
    path: string;
    titleKey: string;
    hidden?: boolean;
}
export declare type PathTreeNode = string | PathTree;
export interface PathTree extends Array<PathTreeNode> {
}
export interface FolderContents {
    [folder: string]: string[];
}
export declare class Pages {
    private pages;
    private folders;
    private calculatedPathTree;
    private calculatedFolderContents;
    private calculatedFilteredPathTree;
    private calculatedFilteredFolderContents;
    constructor(root: PageTreeRoot);
    hasPage(path: string): boolean;
    getPage(path: string): PageDescriptor<any, any, any>;
    hasFolder(path: string): boolean;
    getFolder(path: string): PageFolderDescriptor;
    isHidden(path: string): boolean;
    pathTree: PathTree;
    folderContents: FolderContents;
    filteredPathTree: PathTree;
    filteredFolderContents: FolderContents;
    buildInstance<TProps, TState, TReducerBuilderData>(instantiationData: PageInstantiationData<TReducerBuilderData>): Page<TProps, TState, TReducerBuilderData>;
}
